note
	description: "A default business model."
	author: "Jackie Wang"
	date: "$Date$"
	revision: "$Revision$"

class
	BANK

inherit
	ANY
		redefine
			out
		end

create {BANK_ACCESS}
	make

feature {NONE} -- Initialization
	make
			-- Initialization for `Current'.
		do
			create history.make_empty
			cursor_position := 0
		end

feature -- model operations

	reset
			-- Reset model state.
		do
			make
		end

feature -- bank related features

	balance: INTEGER

	change_balance(nb: INTEGER)
		require
			nb >= 0
		do
			balance := nb
		end

	has_error: BOOLEAN

	toggle_error
		do
			if has_error then
				has_error := false
			else
				has_error := true
			end
		end

feature -- undo/redo related features

	history: ARRAY[DEPOSIT_COMMAND]
	cursor_position: INTEGER

	add_command(c: DEPOSIT_COMMAND)
		do
			history.force (c, history.count + 1)
			cursor_position := cursor_position + 1
		end

	decrement_cursor
		do
			cursor_position := cursor_position - 1
		end

feature -- queries
	out : STRING
		do
			create Result.make_from_string ("  ")
			if has_error then
				Result.append ("Error")
				toggle_error
			else
				Result.append ("balance: " + balance.out)
			end
		end

end




